/*
 * Copyright (c) 1997 Ian W. Dall <ian.dall@dsto.defence.gov.au>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Ian W. Dall.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define	SRWB_BYTCHK	0x02
#define WRITE_VERIFY	0x2e
#define VERIFY		0x2f
#define FORMAT_UNIT	0x04

#define SSD_KEY_RECOVERED 0x01
#define SSD_KEY_MEDIA	0x03
#define SSD_KEY_HARDWARE 0x04

struct scsi_format_unit {
  u_int8_t opcode;
  u_int8_t byte2;
#define SFU_CMPLIST 0x8
#define SFU_FMTDATA 0x10
#define SFU_DEFECT_LIST_FORMAT_MASK 0x7
  u_int8_t unused[1];
  u_int8_t interleave[2];
  u_int8_t control;
};

struct defect_descriptor{
  u_int8_t dlbaddr[4];
};

struct defect_list_header {
  u_int8_t byte0;
  u_int8_t byte1;
#define SDL_VS 0x1
#define SDL_IMMED 0x2
#define SDL_DSP 0x4
#define SDL_IP 0x8
#define SDL_STFP 0x10
#define SDL_DCRT 0x20
#define SDL_DPRY 0x40
#define SDL_FOV  0x80  
  u_int8_t length[2];
};

struct format_unit_parameters {
  struct defect_list_header header;
  struct defect_descriptor defect[1];
};
