/*
 * Copyright (c) 1997 Ian W. Dall <ian.dall@dsto.defence.gov.au>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by Ian W. Dall.
 * 4. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define ST_OK 0
#define ST_SOFT 1
#define ST_HARD 2
#define ST_CONTINUE 3
#define ST_FATAL 4
void disk_info(void);
void analyse_disk(void);
unsigned int scsi_write_verify(FILE *log, unsigned int block, unsigned int nblocks,
			       unsigned int *buf, unsigned int buf_len,
			       int *status);
unsigned int scsi_verify(FILE *log, unsigned int block, unsigned int nblocks,
			 int *status);
void scsi_remap(unsigned int nblocknos, unsigned int *blocknos, int *status);

unsigned int scsi_read(unsigned int block, unsigned int nblocks,
		       unsigned int *buf, unsigned int buf_len,
		       int *status);
unsigned int scsi_write(unsigned int block, unsigned int nblocks,
		       unsigned int *buf, unsigned int buf_len,
		       int *status);

void scsi_format(unsigned int nblocknos, unsigned int *blocknos, bool cmplist,
		 unsigned int interleave, unsigned int timeout, int *status);
